.docker_build_job: &docker_build
  extends: .docker_build

include: 
  - project: practice50/first/stages
    file: stages.yml
    ref: master
  - project: practice50/first/dockerbuild
    file: dockerbuild.yml
    ref: master

.deploy:
  before_script:
     - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
     - export DEPLOY_WHICH="$(echo "${CI_JOB_NAME}" | tr A-Z a-z)"
  script:
    - mkdir -p /var/www/${CI_PROJECT_NAME}/${CI_COMMIT_REF_SLUG}
    - cp -rf . /var/www/${CI_PROJECT_NAME}/${CI_COMMIT_REF_SLUG}
    - cd /var/www/${CI_PROJECT_NAME}/${CI_COMMIT_REF_SLUG}
    - sed "s#image:.*#image:\ ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG}#g" -i ./docker-compose.yml
   # - sed "s/VIRTUAL_HOST:.*/VIRTUAL_HOST:\ ${CI_COMMIT_REF_SLUG}.${DEPLOY_WHICH}.${CI_ENVIRONMENT_URL}/g" -i ./docker-compose.yml
    - docker-compose pull
    - docker-compose -p "${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}" -f "./docker-compose.yml" down
    - echo "$(ls -al .)"
    - docker-compose -p "${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}" -f "./docker-compose.yml" up -d --force-recreate
  after_script:
    - cd /var/www/${CI_PROJECT_NAME}/${CI_COMMIT_REF_SLUG}
    - docker-compose -f "./ingress.yml" up -d --force-recreate
  when: manual

###Build####

develop1:
  <<: *docker_build

develop2:
  <<: *docker_build

develop3:
  <<: *docker_build

###DEPLOY####

Deploy_to_Dev:
  extends:
    - .deploy
    - .to_dev
  when: manual

Deploy_to_Stage:
  extends:
    - .deploy
    - .to_stage
Deploy_to_Prod:
  extends:
    - .deploy
    - .to_prod
